<!DOCTYPE html>
<html>
    <head>
        <title>Cromwell UI</title>
        <!-- UIkit CSS -->
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/uikit/3.1.5/css/uikit.min.css" />

        <!-- UIkit JS -->
        <script src="https://cdnjs.cloudflare.com/ajax/libs/uikit/3.1.5/js/uikit.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/uikit/3.1.5/js/uikit-icons.min.js"></script>
        <script src="/static/js-yaml.min.js"></script>
        <style>
            .uk-navbar-container {
                background-color: #99cbfd;
            }
        </style>
    </head>
    <body>
        <div class="uk-container">
        <nav class="uk-navbar-container uk-navbar-transparent" uk-navbar>
            <div class="uk-navbar-left">
                <ul class="uk-navbar-nav">
                    <li class="{% if 'launch' == active_page %}uk-active{%else%}uk-parent{%endif%}"><a href="launch">Launch</a></li>
                    <li class="{% if 'history' == active_page %}uk-active{%else%}uk-parent{%endif%}"><a href="history">History</a></li>
                </ul>
            </div>
        </nav>
            {% block body %}
            {% endblock%}
       </div>
  </body>
  <script>

    function runIdUserFriendly(runid) {
        // Current implementation uses UUIDs
        // we show the first 12 bytes that correspond to time
        // See https://en.wikipedia.org/wiki/Universally_unique_identifier#Format
        let prefix = runid.substr(0,13) + "..";
        return prefix;
    }

    const showRunStatus = function(runid, status, modalStatus) {
      let msg = '<span class="uk-text-small">' + runid + 
        " : <samp>" + status + "</samp></span>";
      let opts = {message: msg, status: modalStatus, pos: 'top-right'};
      UIkit.notification(opts);
    }
    function showNotification(data) {
        const r = runIdUserFriendly(data.rid);
        if (!("Notification" in window) || Notification.permission === "denied") {
            let status = data.st === 'failed' ? 'danger' : 'primary';
            showRunStatus(r, data.st, status);
            return;
        }
        if (Notification.permission === "granted") {
            let notification = new Notification(r +" "+ data.status);
            setTimeout(notification.close.bind(notification), 4000);
        }
        else {
            Notification.requestPermission(function (permission) {
                // If the user accepts, let's create a notification
                if (permission === "granted") {
                    showNotification(data);
                }
            });
        }
    }

    const evtSource = new EventSource("/monitor");

    evtSource.onmessage = function(e) {
      let data = JSON.parse(e.data);
      showNotification(data);
      if (!!window.updateRun) {
          window.updateRun(data);
      }

    }
    

  </script>
</html>
